#!/bin/sh
echo "updater start!"

BASEDIR=/home/rti/naichichi2/naichichi2

UPDATEURL=`head -n 1 /tmp/naichichi2_updater_url`
if [ "x" == "x$UPDATEURL" ] ; then
	echo "アップデートするURLがありません."
	exit 10
fi

#古いのを消す.
rm /tmp/naichichi2_main_updater.tar.gz /tmp/naichichi2_updater -rf

#ファイルサイズが結構でかいのでバッチで落とす.
#webからだとタイムアウトしちゃう.
wget -O /tmp/naichichi2_main_updater.tar.gz $UPDATEURL
if [ ! -f /tmp/naichichi2_main_updater.tar.gz ]; then
	echo "アップデートの必要はありません."
	exit 20
fi


gunzip --test /tmp/naichichi2_main_updater.tar.gz
GZIPCHECK=$?
if [ "$GZIPCHECK" != "0"  ] ; then
	echo "アップデーターが破損しています(解凍できません)."
	exit 30
fi

#アップデーター解凍.
mkdir /tmp/naichichi2_updater
tar zxvf /tmp/naichichi2_main_updater.tar.gz -C /tmp/naichichi2_updater
if [ ! -f /tmp/naichichi2_updater/VERSION ]; then
	echo "アップデーターが破損しています(VERSIONファイルがありません)."
	exit 40
fi

#実行.
( cd /tmp/naichichi2_updater; sh /tmp/naichichi2_updater/update.sh )

#バージョン番号の置換.
NEWVERSION=`head -n 1 /tmp/naichichi2_updater/VERSION`
cp $BASEDIR/config/config.conf $BASEDIR/config/config.conf.tmp
sed -e "s/^version_number=.*/version_number=$NEWVERSION/" $BASEDIR/config/config.conf.tmp > $BASEDIR/config/config.conf


echo "updater end!"
